Bug 2501 - (int-142843) Hardware keyboard doesn't switch Input language when pressing Ctrl+Space
(int-142843)
: Hardware keyboard doesn't switch Input language when pressing Ctrl+Space
Status: REOPENED
Product: Desktop platform
Input method framework
: 5.0:(10.2010.19-1)
: All Maemo
: Unspecified normal with 37 votes (vote)
: ---
Assigned To: Joaquim Rocha
: input-method-framework-bugs
:
:
:
:
  Show dependency tree
 
Reported: 2007-12-07 14:16 UTC by Lucas Maneos
Modified: 2010-08-06 10:31 UTC (History)
21 users (show)

See Also:


Attachments
Original rx-51 file (18.09 KB, application/octet-stream)
2010-06-05 02:05 UTC, Ivan Daniluk
Details
NEW rx-51 file (18.08 KB, application/octet-stream)
2010-06-05 02:08 UTC, Ivan Daniluk
Details
DIFF against original rx-51 (4.87 KB, text/x-patch)
2010-06-05 02:08 UTC, Ivan Daniluk
Details
FIXED NEW rx-51 (18.04 KB, application/octet-stream)
2010-06-05 11:10 UTC, Ivan Daniluk
Details


Note

You need to log in before you can comment on or make changes to this bug.


Description Lucas Maneos (reporter) 2007-12-07 14:16:55 UTC
STEPS TO REPRODUCE THE PROBLEM:

According to the text input help one is supposed to simultaneously press Chr
and Ctrl to switch keyboard layouts.  This doesn't seem to work.

I start notes, type a bit of text in the default layout and then press
Ctrl+Chr.  This pops up a notification saying "Input language switched",
however any key presses still produce text in the first language.  The issue is
not specific to notes however, I get exactly the same results in the browser,
terminal etc.

Language switching works fine in both the stylus and thumb virtual keyboards,
as well as handwriting.

My text input settings:
Hardware keyboard layout: "English, Nederlands"
Stylus input methods & finger enabled
1st language: English (UK)
2nd language: greek
Use dual dictionaries enabled

EXPECTED OUTCOME:

Switching layouts works.

ACTUAL OUTCOME:

Nothing apart from the notification.

REPRODUCIBILITY:
(always/sometimes/once)

Always

EXTRA SOFTWARE INSTALLED:

A few bits like media players, maemo mapper and claws but nothing relevant to
input methods.

OTHER COMMENTS:

This is with OS2008 1.2007.42-19
Comment 1 Lucas Maneos (reporter) 2007-12-18 16:19:07 UTC
Still have the issue on 2.2007.50-2.  One thing I noticed now (don't know if it
was also true on the previous firmware) is that Ctl+Chr on the physical
keyboard actually switches the language for the stylus keyboard (but physical
keyboard input always stays in english).
Comment 2 Lucas Maneos (reporter) 2008-06-05 18:09:44 UTC
Setting (more) correct OS and crossing fingers for a fix in Diablo...
Comment 3 Aniello Del Sorbo 2008-06-17 19:24:31 UTC
I can confirm this but.
The hardware keyboard does not switch layout,the virtual one does.
Comment 4 Aniello Del Sorbo 2008-06-17 19:28:37 UTC
*** This bug has been confirmed by popular vote. ***
Comment 5 Lucas Maneos (reporter) 2008-06-17 23:05:42 UTC
Exactly.  For extra fun: slide the intergrated keyboard out, press Shift+Space
followed by Chr twice to get the stylus keyboard (or HWR entry widget)
on-screen and watch it change every time you press Ctrl+Chr.
Comment 6 Lucas Maneos (reporter) 2008-06-25 18:39:03 UTC
Updating version since there's no change in Diablo :-(
Comment 7 Karsten Bräckelmann 2008-07-14 23:13:58 UTC
Marking as duplicate of the later filed bug 3407 due to its comments.  A fix
already is been worked on.

Thanks for reporting the issue.


*** This bug has been marked as a duplicate of bug 3407 ***
Comment 8 Karsten Bräckelmann 2008-07-14 23:21:13 UTC
Folks, unfortunately, bugzilla does not inherit the votes when marking as a
duplicate.  Please feel free to add your votes to bug 3407.  Thanks!
Comment 9 Andre Klapper maemo.org 2008-11-20 13:28:05 UTC
Reopen as per bug 3407 comment 18
Comment 10 Andre Klapper maemo.org 2009-03-26 18:44:22 UTC
> According to the text input help one is supposed to simultaneously press 
> Chr and Ctrl to switch keyboard layouts.

I can confirm the behaviour in 4.1.3, but where exactly is this written in the
Help??
It's not in
http://nds1.nokia.com/files/support/nam/phones/guides/N810_US_en.PDF :
"To enter accented letters, hold down [Chr], and press a
letter key repeatedly until the desired accented character
appears. To preview all special characters available, press
[Chr] briefly."
Opening "Settings > Control panel > Text input settings > Help" in the three
available tabs also doesn't mention Chr anywhere.

For your interest, pressing Ctrl+Chr is not defined in Fremantle Input method
UI specification so this will most likely not be supported anyway and is a
WONTFIX for Diablo (not important enough).
Comment 11 Lucas Maneos (reporter) 2009-03-26 19:10:31 UTC
(In reply to comment #10)
> I can confirm the behaviour in 4.1.3, but where exactly is this written in the
> Help??

The on-device help application (I think it was under "My selection" by default
although I have moved it out of the way), under Text input methods ->
Integrated keyboard.

In 5.2008.43-7  (see also bug 3407 comment 14):

> The integrated keyboard layout can vary depending on the device sales region, 
> but the keyboard can still provide two different text input languages at the 
> same time. To switch between two keyboard layouts, press Chr and Ctrl 
> simultaneously.
Comment 12 Andre Klapper maemo.org 2009-03-30 15:33:15 UTC
(In reply to comment #11)
> > I can confirm the behaviour in 4.1.3, but where exactly is this written in 
> > the Help??
> 
> The on-device help application (I think it was under "My selection" by default
> although I have moved it out of the way), under Text input methods ->
> Integrated keyboard.

Hmm. Maybe I've removed it too. Shrug. :-)
I need a way to reproduce this...
Comment 13 Aniello Del Sorbo 2009-03-30 15:54:28 UTC
The help states:

"The integrated keyboard layout can vary depending on the device sales region,
but the keyboard can still provide two different text input languages at the
same time. To switch between two keyboard layouts, press <bold>Chr</bold> and
<bold>Ctrl</bold> simultaneously."
Comment 14 Lucas Maneos (reporter) 2009-04-02 14:30:39 UTC
(In reply to comment #12)
> I need a way to reproduce this...

The above help text can be found in various languages in
/usr/share/osso-help/*/WesternTextInput.xml (warning: very long lines), from
package help-contents-common.  The help app itself is package osso-help-ui.

After a bit of more digging/experimentation, AFAICT the Ctl+Chr handler looks
at the hardware keyboard layout configured in the text input settings control
panel, and switches between that and English.  This explains my case (UK model
configured with English layout) where it's effectively a nop (modulo the
notification and the layout switch of the touchscreen input methods), and also
bug 3407 comment 15.

IMHO the layout should switch between the two configured languages (so there is
parity between the hardware & on-screen layouts), or at the very least leave
the touchscreen layouts alone.  Does the UI spec describe the intended
behaviour?

In the meantime, I discovered elkeyboard
(http://maemo.org/downloads/product/OS2008/elkeyboard/, looks like a fork of
ukeyboard (http://upir.cz/maemo/keyboards/)) which solves my immediate problem
:-)
Comment 15 Andre Klapper maemo.org 2009-06-08 15:21:18 UTC
Using Control+Chr will not be supported in Fremantle anymore (WONTFIX).
This is also a WONTFIX for Diablo as Diablo is in maintenance mode and Nokia
will only provide bugfixes for critical issues if at all.
For your interest the Mer project aims to provide a community backport of
Fremantle for N8x0 devices. See http://wiki.maemo.org/Mer for more information.
Comment 16 Lucas Maneos (reporter) 2009-06-09 05:30:50 UTC
(In reply to comment #15)
> Using Control+Chr will not be supported in Fremantle anymore (WONTFIX).

The actual mechanics of the switch are not that important.  Surely there will
be *some* way to switch layouts on the physical keyboard?
Comment 17 Andre Klapper maemo.org 2009-06-09 16:17:55 UTC
(In reply to comment #16)
> The actual mechanics of the switch are not that important.  Surely there will
> be *some* way to switch layouts on the physical keyboard?

Yes, there definitely is (not on the fly though - you have to go to the
Settings).
Comment 18 Lucas Maneos (reporter) 2009-06-11 04:24:16 UTC
Hm, I just noticed example 12 in
<http://maemo.org/development/sdks/maemo_5_examples/>.  The same gconf key
works identically on N810/Diablo, so running for example:

gconftool-2 -s /apps/osso/inputmethod/int_kb_layout -t string fr

immediately switches the hardware keyboard layout to AZERTY.

This could mean that the literal Ctrl+Chr combination not working in Fremantle
may be entirely superficial.  Sure enough, looking at rx51_keymap in the
Fremantle Beta kernel it looks like Chr (aka KEY_COMPOSE) is not available.

(Aside: how would one enter accents/diacriticals then?)

The layout switching function could be assigned to another key combination
though - some suggestions (all available in GNOME keyboard layout options):
Shift+Fn, Ctrl+Fn, Shift+Ctrl, Fn+Space.
Comment 19 Andre Klapper maemo.org 2009-06-11 04:28:35 UTC
(In reply to comment #18)
> (Aside: how would one enter accents/diacriticals then?)

I can assure you that it is definitely possible in Fremantle. I've seen it
myself on a machine running Fremantle, with a hardware keyboard. :-)
Comment 20 Lucas Maneos (reporter) 2009-10-09 22:57:49 UTC
(In reply to comment #17)
> Yes, there definitely is (not on the fly though - you have to go to the
> Settings).

After some experimentation I found the magic switch combination: Ctrl+Space.

Other than that, the situation is the same as in Chinook & Diablo.  Pressing
the switch combination shows an "Input language switched" message, but the
virtual keyboard switches language instead.

Tested with 1.2009.41-10.
Comment 21 Lucas Maneos (reporter) 2009-10-12 20:36:38 UTC
*** Bug 5322 has been marked as a duplicate of this bug. ***
Comment 22 Andre Klapper maemo.org 2009-10-13 14:03:24 UTC
So now I get confused about what is the exact issue here, and the expectations.
:-)

When having set English and German plus dual dictionaries enabled, using Notes
and the N900 hardware keyboard the Language switch seems to make the
auto-completion proposals either English or German.
It does not switch the hardware keyboard layout, and I don't think that this
would make sense either, as the keyboard design is so different compared to
normal QWERTY keyboards out there that you could not find a single sign when
using the blue (Fn) keys.

Switching does work for the onscreen keyboard for me.
Comment 23 luarvique 2009-10-13 14:09:58 UTC
(In reply to comment #22)
> It does not switch the hardware keyboard layout, and I don't think that this
> would make sense either, as the keyboard design is so different compared to
> normal QWERTY keyboards out there that you could not find a single sign when
> using the blue (Fn) keys.
It should switch the hardware keyboard layout, design or no design. Just
because the second layout is not inscribed on keys does not mean that you
shouldn't be able to switch and use it. For examples, please refer to how the
keyboard switch works in GNOME on Ubuntu desktop.
Comment 24 Lucas Maneos (reporter) 2009-10-13 16:15:23 UTC
The current on-device documentation (file:///home/user/MyDocs/.documents/User
Guides/.en/GUID-3E4460CC-6840-44A9-A66C-5FAEC8B0A660.html#d0e2615) says:

> Switch keyboard layout
> 
> The physical keyboard layout can vary by region, but the keyboard can still
> provide two different text input languages at the same time.
> 
> Switch between input languages
> 
> * Press the ctrl and space keys simultaneously. This also switches the
> languages for the virtual keyboard.
Comment 25 Andre Klapper maemo.org 2009-10-13 16:35:53 UTC
Thanks! Now either the implementation is wrong, or the User Guide... :-)
Comment 26 Andre Klapper maemo.org 2009-10-13 20:45:23 UTC
General issue, also in browser, notes, email, conversations.
Comment 27 Urho Konttori 2009-11-07 14:31:54 UTC
We'll take a look at this.
Comment 28 luarvique 2009-12-02 08:50:34 UTC
Still occurs in the latest firmware (2009.42-11). Prevents use of physical
keyboard when having to type in any other language than English. Please, fix
this bug! It is not simply an inconvenience, but a real problem for bilingual
users.
Comment 29 Mikko Vartiainen 2009-12-02 16:20:49 UTC
It has never occured to that switching input language should change the actual
keyboard layout too. I would find it very annoying, but I guess it depends
which languages you are using and which hw kb layout you have.

But the fact that system doesn't tell which input language was selected when
switching is annoying. As a result I have finnish and english dictionaries
completely messed up because it learns what you're typing...
Comment 30 Andre Klapper maemo.org 2009-12-02 17:58:39 UTC
(In reply to comment #27)
> We'll take a look at this. 

Urho: Also see internal ticket 142843 (and feel free to comment of course).
Comment 31 Urho Konttori 2009-12-09 11:28:04 UTC
The Ctrl+Space on languages other than Russian changes the input language, not
the keyboard layout.

I'll investigate the options with the UI designers, but I fear we won't do
anything about this, as changing the kb layout will be confusing for the end
users who are not technical. KB should follow the stamps that are printed on
the kb itself. On russian kbs, the english layout is also printed on the keys
afaik, so for them it's logical.
Comment 32 luarvique 2009-12-09 12:41:09 UTC
(In reply to comment #31)
> The Ctrl+Space on languages other than Russian changes the input language, not
> the keyboard layout.
Wait. You mean that this bug is specific for situations when the secondary
language is Russian? This does not sound logical at all. If I select the second
language in the Settings, I should be able to switch to it using official
means, different layout or not.

> I'll investigate the options with the UI designers, but I fear we won't do
> anything about this, as changing the kb layout will be confusing for the end
> users who are not technical. KB should follow the stamps that are printed on
> the kb itself. On russian kbs, the english layout is also printed on the keys
> afaik, so for them it's logical. 
If the user has selected Russian as his secondary layout on a device with
Roman-only keyboard, it feels completely logical to me to assume that the user
knows what he is doing. There is plenty of people who use Russian keyboard
layout on PC keyboards that have no Cyrillic inscriptions. This may sound
counter-intuitive to non-Russians, but this is just how things are. Ask around
Nokia office, and I am sure you can get this statement confirmed by Russian
speakers.
Comment 33 Aniello Del Sorbo 2009-12-09 13:01:30 UTC
Moreover, I just came back from Barcelona Maemo Long weekend and there were
plenty of UX/UI experts that worked for Nokia on the N900 and one of them gave
a nice talk on the Maemo UX and one of his slide was about the Maemo 5 target
group.
The slide states Nokia targeted the N900 to people that are very technical,
"digital natives" as they call them.

See [http://www.flickr.com/photos/anidel/4170457832/]

So your argument that it may seem un logical to non technical people does not
apply here.
Comment 34 Lucas Maneos (reporter) 2009-12-09 13:16:21 UTC
(In reply to comment #31)
> The Ctrl+Space on languages other than Russian changes the input language, not
> the keyboard layout.

Greek too (as originally reported), and I'm guessing anything non-latin.

> I'll investigate the options with the UI designers, but I fear we won't do
> anything about this, as changing the kb layout will be confusing for the end
> users who are not technical. KB should follow the stamps that are printed on
> the kb itself.

Well, there's already another official way of changing the layout (Settings ->
Text input -> Hardware keyboard layout) so that argument seems dubious.

(In reply to comment #32)
> If I select the second
> language in the Settings, I should be able to switch to it using official
> means, different layout or not.

Fully agree.  Even if the user wants to use some "illogical" configuration like
Russian & French on a Spanish unit they should be allowed to do so.

(In reply to comment #33)
> The slide states Nokia targeted the N900 to people that are very technical,
> "digital natives" as they call them.
> 
> See [http://www.flickr.com/photos/anidel/4170457832/]

Not accessible without a yahoo login, sadly.  Though I don't agree that being
familiar with one's native keyboard layout(s) is "technical".
Comment 35 Aniello Del Sorbo 2009-12-09 13:20:54 UTC
Sorry, the image should be publicly viewable now.
Comment 36 S. Kalogreades 2009-12-09 21:18:58 UTC
(In reply to comment #34)
> (In reply to comment #31)

I agree. I never use the virtual keyboard (which is why I bought a device with
a hardware keyboard). The inability to switch the layout means that I am unable
to type text in Greek. The fact that the physical keys have no indication of
the alternate letters does not really mean much to me as most PC keyboards you
find in the USA are English-only yet I and thousands of others can type in
Greek.
Comment 37 Faidon Liambotis 2009-12-13 10:33:21 UTC
(In reply to comment #31)
> The Ctrl+Space on languages other than Russian changes the input language, not
> the keyboard layout.
> 
> I'll investigate the options with the UI designers, but I fear we won't do
> anything about this, as changing the kb layout will be confusing for the end
> users who are not technical. KB should follow the stamps that are printed on
> the kb itself. On russian kbs, the english layout is also printed on the keys
> afaik, so for them it's logical. 
I was in the process of writing a layout for Greek. It took me 10min. to write
the xkb map and and another 2-3 hours to discover the Ctrl+Space "keyboard
layout switched" vs. "input language switched" subtle difference.

Changing the behavior of a key combination based on the language selected was
something that was totally undocumented and unexpected. I even had a friend
look over the Russian manual to find out how the language is supposed to be
changed there :)

I've resorted in re-using "ru" for the Greek layout of mine.

It'd be nice if this was fixed somehow; it'd be also nice if we were able to
add more languages to Settings dynamically instead of having them hardcoded at
western_common_vim_settings.so, but I guess that warrants a separate bug.
Comment 38 Alexander 2010-01-02 12:52:10 UTC
Switching layouts works in GTK applications. But when i open Qt application it
stops working. Here is what i do:
1. Set Russian layout in settings
2. Open Qt applications with input fields
3. Start typing in this fields using hardware keyboard (by default it starts
typing in English) an try to switch layout to Russian using Ctrl+Space

EXPECTED OUTCOME:
Layout is changed to Russian

ACTUAL OUTCOME:
Noting happens (not even a notification). Layout stays English.

If I change layout to Russian in GTK application and then start Qt application
I can type using Russian layout but I can't switch back to English. And another
strange behavior is layout is Russian in Qt application is that when I press
backspace is does not delete the character but types "1" instead. (should i
make a separate bug for that?)
My firmware version is 1.2009.42.11.
Comment 39 luarvique 2010-01-02 13:11:20 UTC
(In reply to comment #38)
> Switching layouts works in GTK applications. But when i open Qt application it
> stops working.
This has nothing to do with the bug #2501 to which you are commenting. Bug
#2501 is about being unable to switch physical keyboard layout between primary
and secondary language layouts with Ctrl+Space. Please, file a new bug for your
problem.
Comment 40 Alexander 2010-01-02 13:33:20 UTC
(In reply to comment #39)
> (In reply to comment #38)
> > Switching layouts works in GTK applications. But when i open Qt application it
> > stops working.
> This has nothing to do with the bug #2501 to which you are commenting. Bug
> #2501 is about being unable to switch physical keyboard layout between primary
> and secondary language layouts with Ctrl+Space. Please, file a new bug for your
> problem.
But my problem is that I can't switch between primary and secondary language
layouts with Ctrl+Space using physical keyboard. But now this only happens in
Qt applications. Should i really make a separate bug for this?
Comment 41 luarvique 2010-01-02 13:35:48 UTC
(In reply to comment #40)
> But my problem is that I can't switch between primary and secondary language
> layouts with Ctrl+Space using physical keyboard. But now this only happens in
> Qt applications. Should i really make a separate bug for this?
Yes, you should file your bug against QT Libraries rather than Hildon Input
Method.
Comment 42 Faidon Liambotis 2010-01-02 15:16:35 UTC
Well, the underlying problem in both problems is that the current
implementation for switching input languages and keyboard layouts in HIM is a
badly-working hack (and on top of it all, this hack is a proprietary plugin to
the opensource HIM that we can't begin to fix).

And by hack I mean that a) it employs modifiers/level switches instead of xkb
groups and thus making it Hildon/Gtk-only, b) the switch key combination has
different semantics based on the language selected ("Input language switched"
on non-ru vs. "Keyboard layout switched" on ru).

This has various effects, both those documented here as many other, smaller,
problems that aren't worth mentioning here.

I'm new to Nokia & Maemo's practices on this matters; please advise on how to
proceed with fixing all of these bugs properly once and for all. I'm pretty
sure, though, that there are people within Nokia that are aware of these issues
(see e.g. the comments on the rx-51 xkb map).
Comment 43 Alexey Guseynov 2010-01-02 15:38:21 UTC
> strange behavior is layout is Russian in Qt application is that when I press
> backspace is does not delete the character but types "1" instead. (should i
> make a separate bug for that?)
> My firmware version is 1.2009.42.11.
> 

A little more details. Blue arrow key produces "." symbol and additionally
works as modifier. If I press blue arrow and then A ".*" would be entered. And
if you press blue arrow backspace deletes symbol before cursor and enters "1".
Pressing blue arrow would give ".", pressing backspace would delete dot and add
1 resulting in "1". Witout blue arrow backspace just adds 1.
Comment 44 Urho Konttori 2010-01-05 21:56:14 UTC
We had a discussion ad we agreed to fix this for PR1.2 for all languages. 

jrocha, go ahead and duplicate this to internal and make it happen. Agreed with
Product management as well.
Comment 45 Urho Konttori 2010-01-15 21:36:26 UTC
Looks like it's doable. We have nice solution for this that simplifies the
control panel as well, so everybody wins (even UX guys are happy : simplifies
UI==good)
Comment 46 pzafiris 2010-02-17 18:20:05 UTC
This is pretty much a blocker, as it's disrupting usability of the physical
keyboard in key applications. Such as looking up a contact with greek
characters; or entering an appointment, with greek characters again.

I would kindly recommend that the priority be raised.

Any ETA on PR1.2?
Comment 47 Urho Konttori 2010-02-20 20:05:49 UTC
Integrated to PR1.2 branch now. Nokia policy is not to announce the dates
beforehand. You'll just have to wait.
Comment 48 Urho Konttori 2010-02-20 20:07:25 UTC
Setting as fixed. Verify when you have pr1.2 in your hands.
Comment 49 Andre Klapper maemo.org 2010-03-15 20:53:12 UTC
Setting explicit PR1.2 milestone (so it's clearer in which public release the
fix will be available to users).

Sorry for the bugmail noise (you can filter on this message).
Comment 50 Andre Klapper maemo.org 2010-03-16 23:48:01 UTC
(In reply to comment #48)
> Setting as fixed. Verify when you have pr1.2 in your hands.

Urho, this is definitely not fixed in 2010.10-10 here.
Can you elaborate why you think this is fixed?
Comment 51 Andre Klapper maemo.org 2010-03-16 23:54:00 UTC
Assuming that comment 31 is outdated nowadays.
I guess Urho had reasons for comment 44, however I don't get it either.
Restoring previous state. Sorry for the noise.
Comment 52 Vincent Lefevre 2010-03-17 15:37:24 UTC
I'm worried. I use two languages, English and French, and switch input language
to change the dictionary. But I certainly don't want to change the layout from
QWERTY to AZERTY when I type French text: it would bring nothing for the N900
keyboard except annoyances (typing 'Q' would give an 'A' and so on).
Comment 53 Lucas Maneos (reporter) 2010-03-20 10:04:50 UTC
(In reply to comment #52)
> I'm worried. I use two languages, English and French, and switch input language
> to change the dictionary. But I certainly don't want to change the layout from
> QWERTY to AZERTY when I type French text

If you want to type French text on a UK/US keyboard layout, isn't that what the
"Use dual dictionaries" option is for?  Of course that can only work when both
languages use the same character set, but the world is more than ISO-8859-1 ;-)
Comment 54 Vincent Lefevre 2010-03-20 13:16:51 UTC
(In reply to comment #53)
> If you want to type French text on a UK/US keyboard layout, isn't that what the
> "Use dual dictionaries" option is for?

It is ticked. But I don't understand the question.

> Of course that can only work when both languages use the same character set,
> but the world is more than ISO-8859-1 ;-)

The dictionaries are provided by Maemo. I hope they are both in UTF-8.
Comment 55 Lucas Maneos (reporter) 2010-03-20 13:30:32 UTC
(In reply to comment #54)
> It is ticked. But I don't understand the question.

It's supposed to enable both dictionaries simultaneously without the need to
switch the keyboard.

> The dictionaries are provided by Maemo. I hope they are both in UTF-8.

My point was that having two dictionaries active is useless when you can't
*enter* the characters of one of the languages.
Comment 56 Vincent Lefevre 2010-03-20 13:51:29 UTC
(In reply to comment #55)
> (In reply to comment #54)
> > It is ticked. But I don't understand the question.
> 
> It's supposed to enable both dictionaries simultaneously without the need to
> switch the keyboard.

No, only one is enabled, and the other one is used as a fallback. For instance,
if one types "op", then "opéré" is proposed when French is the input language,
but "open" is proposed when English is the input language. So, if I want to
type some text in French, I need to select the French input language, otherwise
most proposed completions would be in English, which is rather useless.
Comment 57 Lucas Maneos (reporter) 2010-03-21 12:58:32 UTC
(In reply to comment #56)
> No, only one is enabled, and the other one is used as a fallback.

Thanks for explaining (the option does nothing with my language combination for
obvious reasons).
Comment 58 Urho Konttori 2010-04-04 21:59:59 UTC
we needed to revert the fix. reverting bug state as well.
Comment 59 luarvique 2010-04-04 22:20:29 UTC
(In reply to comment #58)
> we needed to revert the fix. reverting bug state as well. 
Could you explain why? Does it break something else?
Comment 60 Saturn 2010-04-17 16:36:40 UTC
Yes, could you please give more info?

Us, wanting to be able to write in a different language using the hardware
keyboard have anticipated this fix for quite some time already!

Thanks.
Comment 61 George Deligeo 2010-04-17 21:56:28 UTC
I've followed the entire conversation so far, although I am also greek writer,
I do see the implications of changing the keyboard layout for ISO-8859-1 based
languages (French AZERTY and UK QWERTY is a good example)
So I propose the following assuming it is doable:
An extra option in text input settings that will control whether the keyboard
layout should change or just the dictionary being used.
This would be like:
[tick/ no tick] Change keyboard layout to follow dictionary?

Let me know if this thought leads somewhere.
George
Comment 62 Saturn 2010-05-23 01:53:54 UTC
(In reply to comment #61)
> I've followed the entire conversation so far, although I am also greek writer,
> I do see the implications of changing the keyboard layout for ISO-8859-1 based
> languages (French AZERTY and UK QWERTY is a good example)
> So I propose the following assuming it is doable:
> An extra option in text input settings that will control whether the keyboard
> layout should change or just the dictionary being used.
> This would be like:
> [tick/ no tick] Change keyboard layout to follow dictionary?
> 
> Let me know if this thought leads somewhere.
> George
> 

That's the most favorable solution in my opinion.

Since I saw a few WONTFIXes because of UI specs change requests, I would
propose one more alternative solution that doesnt need one.

Create a config list where a flag change or no change of the keyboard is
required. 
E.g.

# Change H/W keyboard layout on CTRL+Space?
fr=false
el=true
... etc.

By changing the code to interrogate this list the OS would know what is the
wanted behaviour depending on the language.

Hope it makes sense and in any case a working solution for all is found.
Comment 63 Pavel Antonov 2010-05-26 22:43:25 UTC
Just updated to PR1.2. Nothing changes... still cant use russian in Qt
applications.
Comment 64 luarvique 2010-05-26 23:03:53 UTC
Still broken in PR1.2, just like it was before.
Comment 65 Saturn 2010-05-26 23:25:13 UTC
The only difference is that now it displays in the pop-up the language it is
supposed to have.

In my opinion too, it is still broken.
Comment 66 Andre Klapper maemo.org 2010-05-27 00:06:53 UTC
(In reply to comment #64)
> Still broken in PR1.2

Yes, that's why the bug is not in RESOLVED FIXED state. Thanks for retesting
though. :)
Comment 67 Andre Klapper maemo.org 2010-05-29 00:20:29 UTC
*** Bug 10340 has been marked as a duplicate of this bug. ***
Comment 68 Ivan Daniluk 2010-06-05 02:05:35 UTC
Created an attachment (id=2835) [details]
Original rx-51 file
Comment 69 Ivan Daniluk 2010-06-05 02:07:08 UTC
Hi, I use N900 with English keyboard with both Russian and English letters. The
bug exists if I choose hardware layout "English", but everything works if I
choose "Russian" hardware layout. But I don't want to use "Russian" layout
cause it doesn't match my keyboard - 2 arrows instead 4, different symbols
positions in English mode and so on.

Let's take a look at the file: /usr/share/X11/xkb/symbols/nokia_vndr/rx-51 on
N900. 
The English layout consist 'english_base' rules with 4-modes, and Russian
layout extends this to 8 mode keys, which is needed for proper dual layout
switching. Maybe(just an assumption), when Ctrl-Space is pressed, the swith
occurs, but there is nothing to switch for hardware layout - it has only 4
modes.

So, this is the solution for me - I take Russian layout as a base and change
some keys to match original 'english_base" keys. We also need to select
"Russian" hardware layout in Settings.
I attached my original rx-51(just in case), modified one and the diff.
Simply replace original rx-51 with new and run 'setxkbmap ru' command.
Comment 70 Ivan Daniluk 2010-06-05 02:08:08 UTC
Created an attachment (id=2836) [details]
NEW rx-51 file
Comment 71 Ivan Daniluk 2010-06-05 02:08:46 UTC
Created an attachment (id=2837) [details]
DIFF against original rx-51
Comment 72 luarvique 2010-06-05 09:09:03 UTC
(In reply to comment #69)
> So, this is the solution for me - I take Russian layout as a base and change
> some keys to match original 'english_base" keys. We also need to select
> "Russian" hardware layout in Settings.
Huge thanks for this workaround, Ivan! And shame to Nokia for forcing its users
to use workarounds like this one.
Comment 73 luarvique 2010-06-05 09:54:59 UTC
(In reply to comment #70)
> Created an attachment (id=2836) [details] [details]
> NEW rx-51 file
I have installed this file, but it only messes up the keyboard layout. Here is
what I have found:

1. The file, as it is, has got some problem in the following line:

    key <AC06>    { [    h,        H,        parenleft,        parenleft,      
 Cyrillic_er,        Cyrillic_ER,        parenleft,        parenleft        ]
};

xkbsetmap refused to set any layouts out of this file, until I manually edited
spaces in this line (I did not change the content though).

2. When this file is installed and the Russian keyboard layout is selected in
Settings, the English keyboard starts having the following problems:

a) [.] key generates ",".
b) [UP] key generates ".".
c) [DOWN] key does not work.
d) [SHIFT]+[ARROWS] appear to generate stuff like "2C", "2B", etc.

There may be more, I did not look further. Uninstalling it :(
Comment 74 Ivan Daniluk 2010-06-05 11:09:06 UTC
> I have installed this file, but it only messes up the keyboard layout. Here is
> what I have found:
Yes, my bad. There was a problem with missing parentheses, uploading new rx-51.
Comment 75 Ivan Daniluk 2010-06-05 11:10:22 UTC
Created an attachment (id=2842) [details]
FIXED NEW rx-51
Comment 76 luarvique 2010-06-05 11:27:34 UTC
(In reply to comment #75)
> Created an attachment (id=2842) [details] [details]
> FIXED NEW rx-51
Yep. This one has been tested and found to work, at least on a EURO1 N900.
Comment 77 Ilya Fomin 2010-06-23 13:47:14 UTC
Since the issue described in this bug is very generic, I've submitted a new one
that describes PR1.2-specific inability to switch input language when nothing
is typed (in home screen, contacts, app manager etc.). Hopefully, it's not a
duplicate, so feel free to vote for CR 10757 as well if you're suffering from
this.